#pragma once

#include "infra/Audio.h"
#include "infra/Http.h"

class Recorder {
private:
  Audio* _audio;
  Http* _http;

  void _ready();
  void _transcribe();
  void _printContent(String payloadStart, String payloadEnd, Stream* stream);
  void _logContent(String payloadStart, String payloadEnd);
  void _printAudio();

  String _formPayloadStart();
  String _formPayloadEnd();

public:
  Recorder(MicType micType, Http* http);
  ~Recorder();
  void recordAudio();
  bool isNoiseDetected(int threshold);
};
