#pragma once

#include <Arduino.h>

#include "infra/Eth.h"

class Http {
private:
  EthernetClient* _client;

  void _logHeader(String method, String endpoint, String host, String contentType);
  void _logPayload(String payload);
  void _logConnected(String host, int port);

public:
  Http(Eth* eth);

  String send(String method, String endpoint, String host, int port, String payload, String contentType);
  void sendRequest(String method, String endpoint, String host, String contentType, String payload);

  void printHeader(String method, String endpoint, String host, String contentType);
  void printContentLength(int contentLength);
  void printPayload(String payload);

  String readResponse();

  int connect(const char *host, uint16_t port);
  void stop();
  EthernetClient* getClient();

  static String extractBody(String httpResponse);
};